import { css as $, LitElement as D, html as v, svg as C } from "lit";
import { property as S, state as y, customElement as E, query as P } from "lit/decorators.js";
import { a as Q, f as V, b as I, c as q, d as H, e as x, h as k, t as F, i as R } from "./functions.7b9d19fa.js";
import { classMap as f } from "lit/directives/class-map.js";
function h(m, e, t, s) {
  var i = arguments.length, n = i < 3 ? e : s === null ? s = Object.getOwnPropertyDescriptor(e, t) : s, r;
  if (typeof Reflect == "object" && typeof Reflect.decorate == "function")
    n = Reflect.decorate(m, e, t, s);
  else
    for (var a = m.length - 1; a >= 0; a--)
      (r = m[a]) && (n = (i < 3 ? r(n) : i > 3 ? r(e, t, n) : r(e, t)) || n);
  return i > 3 && n && Object.defineProperty(e, t, n), n;
}
class z {
  constructor(e, t) {
    this.runtime = e, this.canvas = t, this.disposed = !1, this.analyser = e.audioCtx.createAnalyser(), this.analyser.fftSize = 8192, this.analyser.smoothingTimeConstant = 0.5, e.connect(this.analyser), this.analysisData = new Uint8Array(this.analyser.frequencyBinCount);
    let s = Math.log10(e.audioCtx.sampleRate / 2) - 1;
    this.canvas.width = this.canvas.offsetWidth * window.devicePixelRatio, this.canvas.height = this.canvas.offsetHeight * window.devicePixelRatio, this.analysisXs = this.calculateAnalysisXs(s), this.resizeObserver = new ResizeObserver(() => {
      this.canvas.width = this.canvas.offsetWidth * window.devicePixelRatio, this.canvas.height = this.canvas.offsetHeight * window.devicePixelRatio, this.analysisXs = this.calculateAnalysisXs(s);
    }), this.resizeObserver.observe(this.canvas);
  }
  calculateAnalysisXs(e) {
    return Array.from(this.analysisData).map((t, s) => {
      let i = s / this.analysisData.length * (this.runtime.audioCtx.sampleRate / 2);
      return Math.floor((Math.log10(i) - 1) / e * this.canvas.width);
    });
  }
  analyse() {
    let e = () => {
      this.disposed || (this.analyser.getByteFrequencyData(this.analysisData), this.draw(), requestAnimationFrame(e));
    };
    requestAnimationFrame(e);
  }
  draw() {
    let e = this.canvas.width, t = this.canvas.height, s = this.canvas.height / 255, i = this.canvas.getContext("2d");
    if (!i)
      throw new Error("Could not get a canvas context!");
    i.clearRect(0, 0, e, t);
    let n = new Path2D();
    n.moveTo(0, t);
    for (let r = 0; r < this.analysisData.length; r++) {
      let a = Math.floor(t - this.analysisData[r] * s);
      n.lineTo(this.analysisXs[r], a);
    }
    n.lineTo(e, t), i.fillStyle = "rgba(30, 30, 60, 0.7)", i.fill(n), i.strokeStyle = "rgb(155, 155, 255)", i.stroke(n);
  }
  dispose() {
    this.disposed = !0, this.analyser.disconnect(), this.resizeObserver.disconnect();
  }
}
class L {
  constructor(e, t) {
    this.runtime = e, this.canvas = t, this.canvas.width = this.canvas.offsetWidth * window.devicePixelRatio, this.canvas.height = this.canvas.offsetHeight * window.devicePixelRatio, this.frequencies = this.calculateFrequencies(), this.filterMagResponse = new Float32Array(this.frequencies.length), this.filterPhaseResponse = new Float32Array(this.frequencies.length), this.frequencyResponse = new Float32Array(this.frequencies.length), this.resizeObserver = new ResizeObserver(() => {
      this.canvas.width = this.canvas.offsetWidth * window.devicePixelRatio, this.canvas.height = this.canvas.offsetHeight * window.devicePixelRatio, this.frequencies = this.calculateFrequencies(), this.filterMagResponse = new Float32Array(this.frequencies.length), this.filterPhaseResponse = new Float32Array(this.frequencies.length), this.frequencyResponse = new Float32Array(this.frequencies.length), this.render();
    }), this.resizeObserver.observe(this.canvas);
  }
  dispose() {
    this.resizeObserver.disconnect();
  }
  render() {
    this.frequencyResponse.fill(1);
    for (let e = 0; e < this.runtime.spec.length; e++)
      for (let t = 0; t < Q(this.runtime.spec[e].type); t++)
        if (this.runtime.getFrequencyResponse(e, t, this.frequencies, this.filterMagResponse, this.filterPhaseResponse))
          for (let i = 0; i < this.frequencyResponse.length; i++)
            this.frequencyResponse[i] *= this.filterMagResponse[i];
    this.draw();
  }
  draw() {
    let e = this.canvas.getContext("2d"), t = this.canvas.width, s = this.canvas.height;
    if (!e)
      throw new Error("Could not get a canvas context!");
    e.clearRect(0, 0, t, s), e.strokeStyle = "#ffffff", e.lineWidth = 2, e.beginPath();
    let i = 13, n = -i;
    for (let r = 0; r < this.frequencyResponse.length; r++) {
      let a = this.frequencyResponse[r], l = 20 * Math.log10(a), o = s - (l - n) / (i - n) * s;
      r === 0 ? e.moveTo(r, o) : e.lineTo(r, o);
    }
    e.stroke();
  }
  calculateFrequencies() {
    let e = new Float32Array(this.canvas.width), t = this.runtime.audioCtx.sampleRate / 2, s = 1, i = Math.log10(t);
    for (let n = 0; n < this.canvas.width; n++) {
      let r = s + n / this.canvas.width * (i - s), a = Math.pow(10, r);
      e[n] = a;
    }
    return e;
  }
}
const A = $`
  *,
  *::before,
  *::after {
    box-sizing: border-box;
  }

  :host {
    background-color: #111;
    color: white;
    --font-stack: Corbel, "Lucida Grande", "Lucida Sans Unicode", "Lucida Sans",
      "DejaVu Sans", "Bitstream Vera Sans", "Liberation Sans", Verdana,
      "Verdana Ref", sans-serif;
    --font-size: 9px;
    font-family: var(--font-stack);
    font-size: var(--font-size);
  }
`, M = [
  ["noop", "-"],
  ["lowpass12", "LP12"],
  ["lowpass24", "LP24"],
  ["highpass12", "HP12"],
  ["highpass24", "HP24"],
  ["lowshelf12", "LS12"],
  ["lowshelf24", "LS24"],
  ["highshelf12", "HS12"],
  ["highshelf24", "HS24"],
  ["peaking12", "PK12"],
  ["peaking24", "PK24"],
  ["notch12", "NT12"],
  ["notch24", "NT24"]
];
var b;
let g = (b = class extends D {
  constructor() {
    super(...arguments), this.frequencyInputFocused = !1, this.dragStates = { frequency: null, gain: null, Q: null };
  }
  render() {
    if (!this.runtime || this.index === void 0)
      return;
    let e = this.runtime.spec[this.index];
    return v`
      <th
        class=${f({ filterNumber: !0, bypassed: e.bypass })}
        @click=${() => this.toggleBypass()}
      >
        ${this.index + 1}
      </th>
      <td>
        <select
          class=${f({ filterTypeSelect: !0, bypassed: e.bypass })}
          @change=${(t) => this.setFilterType(t.target.value)}
        >
          ${M.map(([t, s]) => v`<option value=${t} ?selected=${e.type === t}>
                ${s}
              </option>`)}
        </select>
      </td>
      <td>
        <input
          class=${f({
      frequencyInput: !0,
      numberInput: !0,
      bypassed: e.bypass
    })}
          type="number"
          step="0.1"
          lang="en_EN"
          .value=${V(e.frequency, this.frequencyInputFocused)}
          ?disabled=${!I(e.type)}
          @focus=${() => this.frequencyInputFocused = !0}
          @blur=${() => {
      this.frequencyInputFocused = !1, this.setFilterFrequency(q(e.frequency, 10, this.nyquist));
    }}
          @input=${(t) => this.setFilterFrequency(t.target.valueAsNumber)}
          @pointerdown=${(t) => this.startDraggingValue(t, "frequency")}
          @pointerup=${(t) => this.stopDraggingValue(t, "frequency")}
          @pointermove=${(t) => this.dragValue(t, "frequency")}
        />
        <span
          class=${f({
      frequencyUnit: !0,
      disabled: !I(e.type),
      bypassed: e.bypass
    })}
          >${H(e.frequency, this.frequencyInputFocused)}</span
        >
      </td>
      <td>
        <input
          class=${f({
      gainInput: !0,
      numberInput: !0,
      bypassed: e.bypass
    })}
          type="number"
          min="-15"
          max="15"
          step="0.1"
          lang="en_EN"
          .value=${e.gain.toFixed(1)}
          ?disabled=${!x(e.type)}
          @input=${(t) => this.setFilterGain(t.target.valueAsNumber)}
          @pointerdown=${(t) => this.startDraggingValue(t, "gain")}
          @pointerup=${(t) => this.stopDraggingValue(t, "gain")}
          @pointermove=${(t) => this.dragValue(t, "gain")}
        />
        <span
          class=${f({
      gainUnit: !0,
      disabled: !x(e.type),
      bypassed: e.bypass
    })}
          >dB</span
        >
      </td>
      <td>
        <input
          class=${f({
      qInput: !0,
      numberInput: !0,
      bypassed: e.bypass
    })}
          type="number"
          min="0.1"
          max="18"
          step="0.1"
          .value=${e.Q.toFixed(2)}
          ?disabled=${!k(e.type)}
          @input=${(t) => this.setFilterQ(t.target.valueAsNumber)}
          @pointerdown=${(t) => this.startDraggingValue(t, "Q")}
          @pointerup=${(t) => this.stopDraggingValue(t, "Q")}
          @pointermove=${(t) => this.dragValue(t, "Q")}
        />
      </td>
    `;
  }
  get nyquist() {
    var e, t;
    return ((t = (e = this.runtime) == null ? void 0 : e.audioCtx.sampleRate) != null ? t : 48e3) / 2;
  }
  toggleBypass() {
    !this.runtime || this.index === void 0 || (this.runtime.toggleBypass(this.index, !this.runtime.spec[this.index].bypass), this.dispatchEvent(new CustomEvent("change", { bubbles: !0, composed: !0 })));
  }
  setFilterType(e) {
    !this.runtime || this.index === void 0 || (this.runtime.setFilterType(this.index, e), this.dispatchEvent(new CustomEvent("change", { bubbles: !0, composed: !0 })));
  }
  setFilterFrequency(e) {
    !this.runtime || this.index === void 0 || isNaN(e) || (this.runtime.setFilterFrequency(this.index, e), this.dispatchEvent(new CustomEvent("change", { bubbles: !0, composed: !0 })));
  }
  setFilterGain(e) {
    !this.runtime || this.index === void 0 || isNaN(e) || (this.runtime.setFilterGain(this.index, e), this.dispatchEvent(new CustomEvent("change", { bubbles: !0, composed: !0 })));
  }
  setFilterQ(e) {
    !this.runtime || this.index === void 0 || isNaN(e) || (this.runtime.setFilterQ(this.index, e), this.dispatchEvent(new CustomEvent("change", { bubbles: !0, composed: !0 })));
  }
  startDraggingValue(e, t) {
    !this.runtime || this.index === void 0 || (e.target.setPointerCapture(e.pointerId), e.preventDefault(), this.dragStates = {
      ...this.dragStates,
      [t]: {
        pointer: e.pointerId,
        startY: e.clientY,
        startValue: this.runtime.spec[this.index][t]
      }
    });
  }
  stopDraggingValue(e, t) {
    var s;
    !this.runtime || this.index === void 0 || ((s = this.dragStates[t]) == null ? void 0 : s.pointer) === e.pointerId && (e.target.releasePointerCapture(e.pointerId), this.dragStates[t].startValue !== this.runtime.spec[this.index][t] && e.target.blur(), this.dragStates = { ...this.dragStates, [t]: null });
  }
  dragValue(e, t) {
    if (!this.runtime || this.index === void 0)
      return;
    let s = this.dragStates[t];
    if (s && s.pointer === e.pointerId) {
      let i = s.startY, r = -(e.clientY - i), a = q(r / 150, -1, 1);
      if (t === "frequency") {
        let l = 10, o = this.runtime.audioCtx.sampleRate / 2, u = F(s.startValue, l, o), d = R(u + a, l, o);
        this.runtime.setFilterFrequency(this.index, d);
      } else if (t === "gain") {
        let l = a * 15;
        this.runtime.setFilterGain(this.index, q(s.startValue + l, -15, 15));
      } else if (t === "Q") {
        let l = 0.1, o = 18, u = F(s.startValue, l, o), d = R(u + a, l, o);
        this.runtime.setFilterQ(this.index, d);
      }
      this.dispatchEvent(new CustomEvent("change", { bubbles: !0, composed: !0 }));
    }
  }
}, (() => {
  b.styles = [
    A,
    $`
      :host {
        display: table-row;
      }
      input,
      select {
        padding: 0;
        border: 0;
      }
      .filterNumber {
        width: 10px;
        cursor: pointer;
      }
      .filterTypeSelect {
        width: 30px;

        appearance: none;
        outline: none;
        background-color: transparent;
        color: white;
        cursor: pointer;
        text-align: center;
        font-family: var(--font-stack);
        font-size: var(--font-size);
      }
      .frequencyInput {
        width: 20px;
      }
      .gainInput {
        width: 23px;
      }
      .qInput {
        width: 30px;
      }
      .numberInput {
        appearance: none;
        outline: none;
        background-color: transparent;
        color: white;
        text-align: right;
        -moz-appearance: textfield;
        font-family: var(--font-stack);
        font-size: var(--font-size);
        touch-action: none;
      }
      .numberInput:disabled,
      .disabled {
        color: #555;
        pointer-events: none;
      }
      .bypassed {
        color: #555;
      }
      .numberInput::-webkit-inner-spin-button,
      .numberInput::-webkit-outer-spin-button {
        -webkit-appearance: none !important;
        margin: 0 !important;
      }
    `
  ];
})(), b);
h([
  S({ attribute: !1 })
], g.prototype, "runtime", void 0);
h([
  S()
], g.prototype, "index", void 0);
h([
  y()
], g.prototype, "frequencyInputFocused", void 0);
h([
  y()
], g.prototype, "dragStates", void 0);
g = h([
  E("weq8-ui-filter-row")
], g);
var w;
let c = (w = class extends D {
  constructor() {
    super(...arguments), this.gridXs = [], this.dragStates = {};
  }
  updated(e) {
    var t, s;
    if (e.has("runtime") && ((t = this.analyser) == null || t.dispose(), (s = this.frequencyResponse) == null || s.dispose(), this.runtime && this.analyserCanvas && this.frequencyResponseCanvas)) {
      this.analyser = new z(this.runtime, this.analyserCanvas), this.analyser.analyse(), this.frequencyResponse = new L(this.runtime, this.frequencyResponseCanvas), this.frequencyResponse.render();
      let i = [], n = this.runtime.audioCtx.sampleRate / 2, r = Math.floor(Math.log10(n));
      for (let a = 0; a < r; a++) {
        let l = Math.pow(10, a + 1);
        for (let o = 1; o < 10; o++) {
          let u = l * o;
          if (u > n)
            break;
          i.push((Math.log10(u) - 1) / (Math.log10(n) - 1) * 100);
        }
      }
      this.gridXs = i;
    }
  }
  render() {
    var e;
    return v`
      <table class="filters">
        <thead>
          <tr>
            <th></th>
            <th>Filter</th>
            <th>Freq</th>
            <th>Gain</th>
            <th>Q</th>
          </tr>
        </thead>
        <tbody>
          ${Array.from({ length: 8 }).map((t, s) => v`<weq8-ui-filter-row
                .runtime=${this.runtime}
                .index=${s}
                @change=${() => {
      var i;
      (i = this.frequencyResponse) == null || i.render(), this.specUpdate();
    }}
              />`)}
        </tbody>
      </table>
      <div class="visualisation">
        <svg
          viewBox="0 0 100 10"
          preserveAspectRatio="none"
          xmlns="http://www.w3.org/2000/svg"
        >
          ${this.gridXs.map(this.renderGridX)}
          ${[12, 6, 0, -6, -12].map(this.renderGridY)}
        </svg>
        <canvas class="analyser"></canvas>
        <canvas class="frequencyResponse"></canvas>
        ${(e = this.runtime) == null ? void 0 : e.spec.filter((t) => t.type !== "noop").map((t, s) => this.renderFilterHandle(t, s))}
      </div>
    `;
  }
  renderGridX(e) {
    return C`<line
      class="grid-x"
      x1=${e}
      y1="0"
      x2=${e}
      y2="10"
    />`;
  }
  renderGridY(e) {
    let s = (e + 15) / 30 * 10;
    return C`<line
      class="grid-y"
      x1="0"
      y1=${s}
      x2="100"
      y2=${s}
    />`;
  }
  renderFilterHandle(e, t) {
    var l, o, u, d;
    if (!this.runtime)
      return;
    let s = this.runtime.spec[t].type, i = (o = (l = this.analyserCanvas) == null ? void 0 : l.offsetWidth) != null ? o : 0, n = (d = (u = this.analyserCanvas) == null ? void 0 : u.offsetHeight) != null ? d : 0, r = F(e.frequency, 10, this.runtime.audioCtx.sampleRate / 2) * i, a = n - (e.gain + 15) / 30 * n;
    return x(s) || (a = n - F(e.Q, 0.1, 18) * n), v`<div
      class="filter-handle-positioner"
      style="transform: translate(${r}px,${a}px)"
      @pointerdown=${(p) => this.startDraggingFilterHandle(p, t)}
      @pointerup=${(p) => this.stopDraggingFilterHandle(p, t)}
      @pointermove=${(p) => this.dragFilterHandle(p, t)}
    >
      <div class="filter-handle">${t + 1}</div>
    </div>`;
  }
  startDraggingFilterHandle(e, t) {
    e.target.setPointerCapture(e.pointerId), this.dragStates = { ...this.dragStates, [t]: e.pointerId }, e.preventDefault();
  }
  stopDraggingFilterHandle(e, t) {
    this.dragStates[t] === e.pointerId && (e.target.releasePointerCapture(e.pointerId), this.dragStates = { ...this.dragStates, [t]: null });
  }
  dragFilterHandle(e, t) {
    var s, i, n;
    if (this.runtime && this.dragStates[t] === e.pointerId) {
      let r = this.runtime.spec[t].type, a = (i = (s = this.frequencyResponseCanvas) == null ? void 0 : s.getBoundingClientRect()) != null ? i : {
        left: 0,
        top: 0,
        width: 0,
        height: 0
      }, l = e.clientX - a.left, o = e.clientY - a.top, u = R(l / a.width, 10, this.runtime.audioCtx.sampleRate / 2);
      this.runtime.setFilterFrequency(t, u);
      let d = 1 - o / a.height;
      if (x(r)) {
        let p = q(d * 30 - 15, -15, 15);
        this.runtime.setFilterGain(t, p);
      } else {
        let p = R(d, 0.1, 18);
        this.runtime.setFilterQ(t, p);
      }
      this.specUpdate(), (n = this.frequencyResponse) == null || n.render();
    }
  }
  specUpdate() {
    var e, t;
    this.requestUpdate();
    for (let s of Array.from((t = (e = this.shadowRoot) == null ? void 0 : e.querySelectorAll("weq8-ui-filter-row")) != null ? t : []))
      s.requestUpdate();
    this.dispatchEvent(new CustomEvent("filterschanged", { bubbles: !0, composed: !0 }));
  }
}, (() => {
  w.styles = [
    A,
    $`
      :host {
        display: flex;
        flex-direction: row;
        align-items: stretch;
        min-width: 600px;
        min-height: 200px;
        padding: 5px;
        overflow: hidden;
      }

      .filters {
        width: 170px;
        border-spacing: 0;
        margin-right: 5px;
      }
      .filters thead th {
        padding-bottom: 10px;
      }

      .visualisation {
        flex: 1;
        position: relative;
      }
      canvas,
      svg {
        position: absolute;
        top: 0;
        left: 0;
        width: 100%;
        height: 100%;
      }
      svg {
        overflow: visible;
      }
      .grid-x,
      .grid-y {
        stroke: #333;
        stroke-width: 1;
        vector-effect: non-scaling-stroke;
      }
      .filter-handle-positioner {
        position: absolute;
        top: 0;
        left: 0;
        width: 30px;
        height: 30px;
        touch-action: none;
      }
      .filter-handle {
        position: absolute;
        top: 0;
        left: 0;
        width: 15px;
        height: 15px;
        border-radius: 50%;
        background-color: #fff;
        color: black;
        transform: translate(-50%, -50%);
        display: flex;
        justify-content: center;
        align-items: center;
        user-select: none;
        cursor: grab;
      }
    `
  ];
})(), w);
h([
  S({ attribute: !1 })
], c.prototype, "runtime", void 0);
h([
  y()
], c.prototype, "analyser", void 0);
h([
  y()
], c.prototype, "frequencyResponse", void 0);
h([
  y()
], c.prototype, "gridXs", void 0);
h([
  y()
], c.prototype, "dragStates", void 0);
h([
  P(".analyser")
], c.prototype, "analyserCanvas", void 0);
h([
  P(".frequencyResponse")
], c.prototype, "frequencyResponseCanvas", void 0);
c = h([
  E("weq8-ui")
], c);
export {
  c as WEQ8UIElement
};
